#ifndef QUDEV_H
#define QUDEV_H

#include <QObject>
#include <QSharedDataPointer>

#include "Enums.h"

#include "QUdev_Global.h"
#include "QUdevDevice.h"

class QUdevData;
class QUdevContext;

class QUDEVSHARED_EXPORT QUdev : public QObject
{
    Q_OBJECT
public:
    explicit QUdev(QObject *parent = 0);
    QUdev(const QUdev &other);
    virtual ~QUdev();

    QUdev &operator=(const QUdev &other);

    const QUdevContext &context() const;

    QString sysPath() const;
    QString devPath() const;
    QString runPath() const;

    int loggingPriority() const;
    void setLoggingPriority(int priority) const;

    QUdevDevice deviceFromSysPath(const QString &sysPath, QObject *parent = 0) const;
    QUdevDevice deviceFromSubsystem(const QString &subsystem, const QString &sysname, QObject *parent) const;
    QUdevDevice deviceFromSubsystem(QUdevNS::Subsystem subsystem, const QString &sysname, QObject *parent) const;
    QUdevDevice deviceFromDeviceFile(const QString &deviceFile, QObject *parent = 0) const;

private:
    QSharedDataPointer<QUdevData> d;
};

#endif // QUDEV_H
